#pragma option -ml

#include <stdio.h>

unsigned char A[201][201];
int N;

void readdata()
{
	FILE * f;
    unsigned long i, m;
	int x, y;

	f = fopen("trasee.in", "rt");
 	fscanf(f, "%d %lu", &N, &m);
    for (i = 0; i < m; i++)
    {
        fscanf(f, "%d %d", &x, &y);
        A[x][y] = 1;
    }
    fclose(f);
}

struct cycle_t
{
	int src, dest;
    int len;
};

int V[201];
int Src;
struct cycle_t C[201];

void df(int node, int level)
{
    int i;

    if (V[node])
    	return;

    V[node] = 1;

	for (i = 1; i <= N; i++)
    {
    	if (A[node][i])
        {
            if (i == Src)
            {
                if (!C[Src].len || level > C[Src].len)
                {
           	        C[Src].dest = node;
                    C[Src].len = level;
                }
            }
            else
            	df(i, level + 1);
        }
    }
}

int Cycles;

int Was[201];
int Dest;
int Path[202];

int df_mark(int node)
{
    int i;

    if (node == Dest)
    {
        Path[++Path[0]] = Dest;
        return 1;
    }

	if (V[node])
    	return 0;
    V[node] = 1;
    for (i = 1; i <= N; i++)
    {
    	if (A[node][i])
        	if (df_mark(i))
            {
                Path[++Path[0]] = node;
            	return 1;
            }
	}
    return 0;
}

int put_cycle(int index, FILE * f)
{
	int i, j;
    struct cycle_t c;
	int ok;

    c = C[index];
    if (!c.len)
    {
    	if (!Was[c.src])
        {
            Was[c.src] = 1;
            fprintf(f, "%d %d\n", c.src, c.src);
            return 1;
        }
        else
        	return 0;
    }
    for (i = 1; i <= N; V[i++] = 0);
    Path[0] = 0; Dest = c.dest;
    df_mark(c.src);
	for (ok = 0, i = Path[0]; i >= 1; i--)
    	if (!Was[Path[i]])
        {
        	ok = 1;
            Was[Path[i]] = 1;
        }
    if (ok)
    {
        for (i = Path[0]; i >= 1; i--)
        	fprintf(f, "%d ", Path[i]);
        fprintf(f, "%d\n", c.src);
        return 1;
    }
    return 0;
}

void arrange1()
{
	FILE * f;
    int i, j, count;
    char s[100];

	f = fopen("trasee.out", "wt");
    fprintf(f, "   \n");
    for (i = 1; i <= N; Was[i++] = 0);
    for (count = 0, i = 1; i <= N; i++)
    {
        if (put_cycle(i, f))
        	count++;
    }
    fclose(f);
    f = fopen("trasee.out", "rb+");
    sprintf(s, "%d", count);
    for (i = 0; s[i]; i++)
    	fwrite(&s[i], 1, 1, f);
    fclose(f);
}

void solve()
{
	int i, j;
	struct cycle_t t;
    int ok;

    for (i = 1; i <= N; i++)
    {
    	C[i].src = i;
        C[i].dest = 0;
        C[i].len = 0;
    }

    for (i = 1; i <= N; i++)
    {
        for (j = 1; j <= N; V[j++] = 0);
        C[i].src = i;
        C[i].len = 0;
        Src = i;
        df(i, 1);
    }

    ok = 1;
    while (ok)
    {
        ok = 0;
        for (j = 2; j <= N; j++)
        {
            if (C[j].len > C[j - 1].len)
            {
            	t = C[j]; C[j] = C[j - 1]; C[j - 1] = t;
                ok = 1;
            }
        }
    }

	arrange1();
}

void main()
{
	readdata();
    solve();
}